import { ReactElement } from 'react';
import { AnyVariables, OperationContext } from '@urql/core';
import { UseQueryArgs, UseQueryState } from '../hooks';
export declare type QueryProps<Data = any, Variables extends AnyVariables = AnyVariables> = UseQueryArgs<Variables, Data> & {
    children: (arg: QueryState<Data, Variables>) => ReactElement<any>;
};
export interface QueryState<Data = any, Variables extends AnyVariables = AnyVariables> extends UseQueryState<Data, Variables> {
    executeQuery: (opts?: Partial<OperationContext>) => void;
}
export declare function Query<Data = any, Variables = any>(props: QueryProps<Data, Variables>): ReactElement<any>;
