import { DocumentNode } from 'graphql';
import { AnyVariables, TypedDocumentNode, OperationResult, OperationContext, CombinedError, Operation } from '@urql/core';
export interface UseMutationState<Data = any, Variables extends AnyVariables = AnyVariables> {
    fetching: boolean;
    stale: boolean;
    data?: Data;
    error?: CombinedError;
    extensions?: Record<string, any>;
    operation?: Operation<Data, Variables>;
}
export declare type UseMutationResponse<Data = any, Variables extends AnyVariables = AnyVariables> = [
    UseMutationState<Data, Variables>,
    (variables: Variables, context?: Partial<OperationContext>) => Promise<OperationResult<Data, Variables>>
];
export declare function useMutation<Data = any, Variables extends AnyVariables = AnyVariables>(query: DocumentNode | TypedDocumentNode<Data, Variables> | string): UseMutationResponse<Data, Variables>;
