import { DocumentNode } from 'graphql';
import { AnyVariables, TypedDocumentNode, CombinedError, OperationContext, Operation } from '@urql/core';
export declare type UseSubscriptionArgs<Variables extends AnyVariables = AnyVariables, Data = any> = {
    query: DocumentNode | TypedDocumentNode<Data, Variables> | string;
    pause?: boolean;
    context?: Partial<OperationContext>;
} & (Variables extends void ? {
    variables?: Variables;
} : {
    variables: Variables;
});
export declare type SubscriptionHandler<T, R> = (prev: R | undefined, data: T) => R;
export interface UseSubscriptionState<Data = any, Variables extends AnyVariables = AnyVariables> {
    fetching: boolean;
    stale: boolean;
    data?: Data;
    error?: CombinedError;
    extensions?: Record<string, any>;
    operation?: Operation<Data, Variables>;
}
export declare type UseSubscriptionResponse<Data = any, Variables extends AnyVariables = AnyVariables> = [
    UseSubscriptionState<Data, Variables>,
    (opts?: Partial<OperationContext>) => void
];
export declare function useSubscription<Data = any, Result = Data, Variables extends AnyVariables = AnyVariables>(args: UseSubscriptionArgs<Variables, Data>, handler?: SubscriptionHandler<Data, Result>): UseSubscriptionResponse<Result, Variables>;
